#!/usr/bin/perl
# Read original include file, and generate export for LDG linker

$file = @ARGV[0];

if ( ! defined(open(FILE, $file)) ) {
	warn "Couldn't open $file: $!\n";
	exit;
}

print "/* Generated by call-gen.pl from $file */\n\n";

$linecount=0;
while ($ligne = <FILE>) {
	# Ignore commented commands
	if ($ligne =~ m=.*/\*.*=) {
		while ($ligne !~ m=.*\*/.*=) {
			$ligne = <FILE>;
		}
		$ligne = <FILE>;
	}

	if ($ligne =~ /static/ ) {
		$ligne =~ s/static *//;
		$ligne =~ s/\.{3}/va_list ap/;

		$call_ligne = $ligne;
		$ligne =~ s/;//;
		$ligne =~ s/\(\*//;
		$ligne =~ s/_p\)//;

		if ($call_ligne =~ /^void +\(/ ) {
			$call_ligne =~ s/void +//;
		} else {
			# Remove return type
			$call_ligne =~ s/^.*\(\*SDL/\(\*SDL/;
			# Complete it
			$call_ligne = "return " . $call_ligne;
		}

		# Remove parameters types
		$call_ligne =~ s/ *const *//g;
		$call_ligne =~ s/ *va_list *//g;
		$call_ligne =~ s/ *char *\**//g;
		$call_ligne =~ s/\(SDL_*\w+\** *\**/\(/g;
		$call_ligne =~ s/, *SDL_*\w+\** *\**/,/g;
		$call_ligne =~ s/ *void +\**//g;
		$call_ligne =~ s/ *void *//g;
		$call_ligne =~ s/(.int[0-9]+ *\**\**)//g;
		$call_ligne =~ s/ *int +\**//g;
		$call_ligne =~ s/ *float +\**//g;
		$call_ligne =~ s/ *FILE +\**//g;
		$call_ligne =~ s/ *int\*//g;
		$call_ligne =~ s/\[[0-9]+\]//g;

		print $ligne;
		print "{\n\t";
		print $call_ligne;
		print "}\n\n";
		$linecount++;
	}
}
close(FILE);
print "/* Functions generated: $linecount */\n";
