/*
	SDL LDG linker

	Copyright (C) 2004	Patrice Mandin

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
*/

/*--- Includes ---*/

#include <gem.h>
#include <ldg.h>

#define DISABLE_X11 /* SDL_syswm.h */

#include <SDL.h>

#include <SDL_active.h>
#include <SDL_audio.h>
#include <SDL_cdrom.h>
#include <SDL_cpuinfo.h>
#include <SDL_endian.h>
#include <SDL_error.h>
#include <SDL_events.h>
/*#include <SDL_getenv.h>*/
#include <SDL_joystick.h>
#include <SDL_keyboard.h>
#include <SDL_loadso.h>
#include <SDL_mouse.h>
#include <SDL_mutex.h>
#include <SDL_rwops.h>
#include <SDL_syswm.h>
#include <SDL_thread.h>
#include <SDL_timer.h>
#include <SDL_version.h>
#include <SDL_video.h>

/*--- Functions prototypes ---*/

/*--- LDG functions ---*/

PROC LibFunc[]={ 
	#include "link-sdl.h"		/*	5	*/
	#include "link-active.h"	/*	1	*/
	#include "link-audio.h"		/*	14	*/
	#include "link-cdrom.h"		/*	11	*/
	#include "link-cpuinfo.h"	/*	8	*/
	#include "link-endian.h"	/*	12	*/
	#include "link-error.h"		/*	3	*/
	#include "link-events.h"	/*	8	*/
/*	#include "link-getenv.h"*/	/*	2	*/
	#include "link-joystick.h"	/*	16	*/
	#include "link-keyboard.h"	/*	6	*/
	#include "link-loadso.h"	/*	3	*/
	#include "link-mouse.h"		/*	8	*/
	#include "link-mutex.h"		/*	17	*/
	#include "link-rwops.h"		/*	6	*/
	#include "link-syswm.h"		/*	1	*/
	#include "link-thread.h"	/*	5	*/
	#include "link-timer.h"		/*	5	*/
	#include "link-version.h"	/*	1	*/
	#include "link-video.h"		/*	57	*/
};

LDGLIB LibLdg[]={ 
	{
		/* library version */
		0x0127,
		/* count of functions in library */
		187,
		/* function addresses */
		LibFunc,
		/* Library information string */
		"SDL library",
		/* Library flags */
		LDG_NOT_SHARED
	}
};

/*
 * Main part : communication with LDG-system
 */

int main(int argc, char *argv[])
{
	if (ldg_init(LibLdg)==-1) {
		appl_init();
		form_alert(1, "[1][This program is a LDG library][End]");
		appl_exit();
	}
	return 0;
}
