#!/usr/bin/perl
# Read link*.h to generate ptr*.h

$file = @ARGV[0];

if ( ! defined(open(FILE, $file)) ) {
	warn "Couldn't open $file: $!\n";
	exit;
}

print "/* Generated by ptr-gen.pl from $file */\n";

$linecount=0;
while ($ligne = <FILE>) {
	# Ignore commented commands
	if ($ligne =~ m=.*/\*.*=) {
		while ($ligne !~ m=.*\*/.*=) {
			$ligne = <FILE>;
		}
		$ligne = <FILE>;
	}

	if ($ligne =~ /\)\",$/ ) {
		# Remove start tabulation and quote
		$ligne =~ s/\t\"//;
		# Remove end quote and comma, replace by semi colon
		$ligne =~ s/\",/;/;
		# Add (xxxx_p) around function name
		$ligne =~ s/(SDL_\w+) *\(/\(\*$1_p\)\(/;
		# Replace many spaces by one
		$ligne =~ s/ +/ /g;	
		# Add static modifier to function pointer
		$ligne = "static " . $ligne;

		print $ligne;
		$linecount++;
	}
}
close(FILE);
print "/* Functions generated : $linecount */\n\n";
